Subject: Re: linux-next: manual merge of the refactor-heap tree with the block tree

From: Matthew Mirvish <[email-masked]>
Date: Thu, 9 May 2024 23:46:18 -0400

On Fri, May 10, 2024 at 11:07:11AM +0800, Kuan-Wei Chiu wrote:
> On Thu, May 09, 2024 at 07:16:31PM -0400, Kent Overstreet wrote:
> > On Fri, May 10, 2024 at 06:44:29AM +0800, Kuan-Wei Chiu wrote:
> > > On Thu, May 09, 2024 at 03:58:57PM -0400, Kent Overstreet wrote:
> > > > On Thu, May 09, 2024 at 03:27:45PM +1000, Stephen Rothwell wrote:
> > > > > Hi all,
> > > > > 
> > > > > Today's linux-next merge of the refactor-heap tree got conflicts in:
> > > > > 
> > > > >   drivers/md/bcache/bset.c
> > > > >   drivers/md/bcache/bset.h
> > > > >   drivers/md/bcache/btree.c
> > > > >   drivers/md/bcache/writeback.c
> > > > > 
> > > > > between commit:
> > > > > 
> > > > >   3a861560ccb3 ("bcache: fix variable length array abuse in btree_iter")
> > > > > 
> > > > > from the block tree and commit:
> > > > > 
> > > > >   afa5721abaaa ("bcache: Remove heap-related macros and switch to generic min_heap")
> > > > > 
> > > > > from the refactor-heap tree.
> > > > > 
> > > > > Ok, these conflicts are too extensive, so I am dropping the refactor-heap
> > > > > tree for today.  I suggest you all get together and sort something out.
> > > > 
> > > > Coli and Kuan, you guys will need to get this sorted out quick if we
> > > > want refactor-heap to make the merge window
> > > 
> > > Hi Coli and Kent,
> > > 
> > > If I understand correctly, the reported bug is because we attempted to
> > > point (heap)->data to a dynamically allocated memory , but at that time
> > > (heap)->data was not a regular pointer but a fixed size array with a
> > > length of MAX_BSETS.
> > > 
> > > In my refactor heap patch series, I introduced a preallocated array and
> > > decided in min_heap_init() whether the data pointer should point to an
> > > incoming pointer or to the preallocated array. Therefore, I am
> > > wondering if my patch might have unintentionally fixed this bug?
> > > 
> > > I am unsure how to reproduce the reported issue. Could you assist me in
> > > verifying whether my assumption is correct?
> > 
> > This is a merge conflict, not a runtime. Can you rebase onto Coli's
> > tree? We'll have to retest.
> 
> Oh, sorry for the misunderstanding I caused. When I mentioned "bug" [1]
> earlier, I was referring to the bug addressed in
> 3a861560ccb3 ("bcache: fix variable length array abuse in btree_iter"),
> not a merge conflict.
> 
> Here are the results after the rebase:
> https://github.com/visitorckw/linux.git refactor-heap
> 
> [1]: https://bugs.launchpad.net/ubuntu/+source/linux/+bug/2039368

The ubuntu kernels build with UBSAN now, and the bug reported is just a
UBSAN warning. The original implementation's iterator has a fixed size
sets array that is indexed out of bounds when the iterator is allocated
on the heap with more space -- the patch restructures it a bit to have a
single iterator type with a flexible array and then a larger "stack"
type which embeds the iterator along with the preallocated region.

I took a brief look at the refactor-heap branch but I'm not entirely
sure what's going on with the new min heaps: in the one place where the
larger iterators are used (in bch_btree_node_read_done) it doesn't look
like the heap is ever initialized (perhaps since the old iter_init
wasn't used here because of the special case it got missed in the
refactor?) With the new heaps it should be fairly easy to fix though;
just change the fill_iter mempool to be allocating only the minheap data
arrays and setup iter->heap.data properly with that instead.

Hope that helps,
Matthew Mirvish

> Regards,
> Kuan-Wei